;-| Single Button |---------------------------------------------------------
[Command]
name = "a"
command = a
time = 1

[Command]
name = "b"
command = b
time = 1

[Command]
name = "c"
command = c
time = 1

[Command]
name = "x"
command = x
time = 1

[Command]
name = "y"
command = y
time = 1

[Command]
name = "z"
command = z
time = 1

[Command]
name = "start"
command = s
time = 1

;-| Hold Dir |--------------------------------------------------------------
[Command]
name = "holdfwd";Required (do not remove)
command = /$F
time = 1

[Command]
name = "holdback";Required (do not remove)
command = /$B
time = 1

[Command]
name = "holdup" ;Required (do not remove)
command = /$U
time = 1

[Command]
name = "holddown";Required (do not remove)
command = /$D
time = 1

[Command]
name = "holda"
command = /a
time = 1

[Command]
name = "holdb"
command = /b
time = 1

[Command]
name = "holdc"
command = /c
time = 1

[Command]
name = "holdx"
command = /x
time = 1

[Command]
name = "holdy"
command = /y
time = 1

[Command]
name = "holdz"
command = /z
time = 1

[Command]
name = "holdstart"
command = /s
time = 1


[Command]
name = "a2"
command = a
time = 1

[Command]
name = "b2"
command = b
time = 1

[Command]
name = "c2"
command = c
time = 1

[Command]
name = "x2"
command = x
time = 1

[Command]
name = "y2"
command = y
time = 1

[Command]
name = "z2"
command = z
time = 1

[Command]
name = "start2"
command = s
time = 1

[Command]
name = "holdfwd2"
command = /$F
time = 1

[Command]
name = "holdback2"
command = /$B
time = 1

[Command]
name = "holdup2"
command = /$U
time = 1

[Command]
name = "holddown2"
command = /$D
time = 1

[Command]
name = "holda2"
command = /a
time = 1

[Command]
name = "holdb2"
command = /b
time = 1

[Command]
name = "holdc2"
command = /c
time = 1

[Command]
name = "holdx2"
command = /x
time = 1

[Command]
name = "holdy2"
command = /y
time = 1

[Command]
name = "holdz2"
command = /z
time = 1

[Command]
name = "holdstart2"
command = /s
time = 1

[Command]
name = "recovery2"
command = x+y
time = 1

[State -1, AI Helper Check]
type = ChangeState
trigger1 = IsHelper(9741)
value = 9741

[State -1, AI Helper Check 2]
type = ChangeState
trigger1 = IsHelper(9742)
value = 9742

; The CMD file.
;
; Two parts: 1. Command definition and  2. State entry
; (state entry is after the commands def section)
;
; 1. Command definition
; ---------------------
; Note: The commands are CASE-SENSITIVE, and so are the command names.
; The eight directions are:
;   B, DB, D, DF, F, UF, U, UB     (all CAPS)
;   corresponding to back, down-back, down, downforward, etc.
; The six buttons are:
;   a, b, c, x, y, z               (all lower case)
;   In default key config, abc are are the bottom, and xyz are on the
;   top row. For 2 button characters, we recommend you use a and b.
;   For 6 button characters, use abc for kicks and xyz for punches.
;
; Each [Command] section defines a command that you can use for
; state entry, as well as in the CNS file.
; The command section should look like:
;
;   [Command]
;   name = some_name
;   command = the_command
;   time = time (optional -- defaults to 15 if omitted)
;
; - some_name
;   A name to give that command. You'll use this name to refer to
;   that command in the state entry, as well as the CNS. It is case-
;   sensitive (QCB_a is NOT the same as Qcb_a or QCB_A).
;
; - command
;   list of buttons or directions, separated by commas.
;   Directions and buttons can be preceded by special characters:
;   slash (/) - means the key must be held down
;          egs. command = /D       ;hold the down direction
;               command = /DB, a   ;hold down-back while you press a
;   tilde (~) - to detect key releases
;          egs. command = ~a       ;release the a button
;               command = ~D, F, a ;release down, press fwd, then a
;          If you want to detect "charge moves", you can specify
;          the time the key must be held down for (in game-ticks)
;          egs. command = ~30a     ;hold a for at least 30 ticks, then release
;   dollar ($) - Direction-only: detect as 4-way
;          egs. command = $D       ;will detect if D, DB or DF is held
;               command = $B       ;will detect if B, DB or UB is held
;   plus (+) - Buttons only: simultaneous press
;          egs. command = a+b      ;press a and b at the same time
;               command = x+y+z    ;press x, y and z at the same time
;   You can combine them:
;     eg. command = ~30$D, a+b     ;hold D, DB or DF for 30 ticks, release,
;                                  ;then press a and b together
;   It's recommended that for most "motion" commads, eg. quarter-circle-fwd,
;   you start off with a "release direction". This matches the way most
;   popular fighting games implement their command detection.
;
; - time (optional)
;   Time allowed to do the command, given in game-ticks. Defaults to 15
;   if omitted
;
; If you have two or more commands with the same name, all of them will
; work. You can use it to allow multiple motions for the same move.
;
; Some common commands examples are given below.
;
; [Command] ;Quarter circle forward + x
; name = "QCF_x"
; command = ~D, DF, F, x
;
; [Command] ;Half circle back + a
; name = "HCB_a"
; command = ~F, DF, D, DB, B, a
;
; [Command] ;Two quarter circles forward + y
; name = "2QCF_y"
; command = ~D, DF, F, D, DF, F, y
;
; [Command] ;Tap b rapidly
; name = "5b"
; command = b, b, b, b, b
; time = 30
;
; [Command] ;Charge back, then forward + z
; name = "charge_B_F_z"
; command = ~60$B, F, z
; time = 10
;
; [Command] ;Charge down, then up + c
; name = "charge_D_U_c"
; command = ~60$D, U, c
; time = 10
;

;-| Super Motions |--------------------------------------------------------
[Command]
name = "one_two_three"
command = ~D, DF, F, D, DF, F, a
time = 20

[Command]
name = "stick_slammer"
command = ~F, F, B, F, y
time = 25

[Command]
name = "super_stick_slammer"
command = ~B, DB, D, DF, F, y
time = 30


;-| Special Motions |------------------------------------------------------
[Command]
name = "elecball"
command = ~B, B, F, b

[Command]
name = "lightning"
command = ~D, DB, B, a

[Command]
name = "elbowblow"
command = ~F, B, F, a

[Command]
name = "teleport"
command = ~D, D
time = 5

[Command]
name = "headstomp"
command = ~D, U
time = 20

[Command]
name = "explosiongrab"
command = ~D, DB, B, D, DB, B, b
time = 20

[Command]
name = "overhead_stick"
command = ~D, DB, B, x

[Command]
name = "upper_x"
command = ~F, D, DF, x

[Command]
name = "upper_y"
command = ~F, D, DF, y

[Command]
name = "upper_xy"
command = ~F, D, DF, x+y

[Command]
name = "QCF_x"
command = ~D, DF, F, x

[Command]
name = "QCF_a"
command = ~D, DF, F, a

[Command]
name = "QCF_b"
command = ~D, DF, F, b

[Command]
name = "QCF_y"
command = ~D, DF, F, y

[Command]
name = "QCF_xy"
command = ~D, DF, F, x+y

[Command]
name = "QCB_a"
command = ~D, DF, F, a

[Command]
name = "QCB_b"
command = ~D, DF, F, b

[Command]
name = "QCB_x"
command = ~D, DB, B, x

[Command]
name = "FF_ab"
command = F, F, a+b

[Command]
name = "FF_a"
command = F, F, a

[Command]
name = "FF_b"
command = F, F, b

;-| Double Tap |-----------------------------------------------------------
[Command]
name = "FF"     ;Required (do not remove)
command = F, F
time = 10

[Command]
name = "BB"     ;Required (do not remove)
command = B, B
time = 10

;-| 2/3 Button Combination |-----------------------------------------------
[Command]
name = "recovery";Required (do not remove)
command = x+y
time = 1

;-| Dir + Button |---------------------------------------------------------
[Command]
name = "down_a"
command = /$D,a
time = 1

[Command]
name = "down_b"
command = /$D,b
time = 1

[Command]
name = "forward_a"
command = /$F,a
time = 1

[Command]
name = "forward_x"
command = /$F,x
time = 1

[Command]
name = "sweep"
command = /$B, x
time = 1

;-| Single Button |---------------------------------------------------------
[Command]
name = "a"
command = a
time = 1

[Command]
name = "b"
command = b
time = 1

[Command]
name = "c"
command = c
time = 1

[Command]
name = "x"
command = x
time = 1

[Command]
name = "y"
command = y
time = 1

[Command]
name = "z"
command = z
time = 1

[Command]
name = "start"
command = s
time = 1

;-| Hold Dir |--------------------------------------------------------------
[Command]
name = "holdfwd";Required (do not remove)
command = /$F
time = 1

[Command]
name = "holdback";Required (do not remove)
command = /$B
time = 1

[Command]
name = "holdup" ;Required (do not remove)
command = /$U
time = 1

[Command]
name = "holddown";Required (do not remove)
command = /$D
time = 1

;---------------------------------------------------------------------------
; 2. State entry
; --------------
; This is where you define what commands bring you to what states.
;
; Each state entry block looks like:
;   [State -1, Label]           ;Change Label to any name you want to use to
;                               ;identify the state with.
;   type = ChangeState          ;Don't change this
;   value = new_state_number
;   trigger1 = command = command_name
;   . . .  (any additional triggers)
;
; - new_state_number is the number of the state to change to
; - command_name is the name of the command (from the section above)
; - Useful triggers to know:
;   - statetype
;       S, C or A : current state-type of player (stand, crouch, air)
;   - ctrl
;       0 or 1 : 1 if player has control. Unless "interrupting" another
;                move, you'll want ctrl = 1
;   - stateno
;       number of state player is in - useful for "move interrupts"
;   - movecontact
;       0 or 1 : 1 if player's last attack touched the opponent
;                useful for "move interrupts"
;
; Note: The order of state entry is important.
;   State entry with a certain command must come before another state
;   entry with a command that is the subset of the first.
;   For example, command "fwd_a" must be listed before "a", and
;   "fwd_ab" should come before both of the others.
;
; For reference on triggers, see CNS documentation.
;
; Just for your information (skip if you're not interested):
; This part is an extension of the CNS. "State -1" is a special state
; that is executed once every game-tick, regardless of what other state
; you are in.


; Don't remove the following line. It's required by the CMD standard.
[Statedef -1]

;--------------------------------------------------------------------------;-
;Run Fwd
;_bV
;[State -1, Run Fwd]
;type = ChangeState
;value = 100
;trigger1 = command = "FF"
;trigger1 = statetype = S
;trigger1 = ctrl

;--------------------------------------------------------------------------;-
;Run Back
;ރ_bV
;[State -1, Run Back]
;type = ChangeState
;value = 105
;trigger1 = command = "BB"
;trigger1 = statetype = S
;trigger1 = ctrl

;===========================================================================
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
;Taunt
;
[State -1, Taunt]
type = ChangeState
value = 195
triggerall = command = "start"
trigger1 = statetype != A
trigger1 = ctrl

;;;;;;;;;;;;;;;;;;;
;;; SUPER MOVES ;;;
;;;;;;;;;;;;;;;;;;;

;One Two Three Combo
[State -1, OneTwoThreeCombo]
type = ChangeState
value = 3000
triggerall = command = "one_two_three"
trigger1 = Power >= 1000
trigger1 = statetype = S
trigger1 = ctrl

;Stick Slammer
[State -1, Stick Slammer]
type = ChangeState
value = 3005
triggerall = command = "stick_slammer"
trigger1 = Power >= 1000
trigger1 = statetype = S
trigger1 = ctrl

;Super Stick Slammer
[State -1, Super Stick Slammer]
type = ChangeState
value = 3010
triggerall = command = "super_stick_slammer"
trigger1 = Power >= 3000
trigger1 = statetype = S
trigger1 = ctrl

;;;;;;;;;;;;;;;;;;;;;
;;; SPECIAL MOVES ;;;
;;;;;;;;;;;;;;;;;;;;;

;ElbowBlow
[State -1, ElbowBlow]
type = ChangeState
value = 1000
triggerall = command = "elbowblow"
trigger1 = statetype = S
trigger1 = ctrl

;Lightning
[State -1, Lightning]
type = ChangeState
value = 1005
triggerall = command = "lightning"
triggerall = NumProj = 0
trigger1 = statetype = S
trigger1 = ctrl

;ElecBall
[State -1, ElecBall]
type = ChangeState
value = 1010
triggerall = command = "elecball"
triggerall = NumProj = 0
trigger1 = statetype = S
trigger1 = ctrl

;Head Stomp
[State -1, HeadStomp]
type = ChangeState
value = 1015
triggerall = command = "headstomp"
trigger1 = ctrl

;Teleport
[State -1, Teleport]
type = ChangeState
value = 1020
triggerall = command = "teleport"
trigger1 = statetype = S
trigger1 = ctrl

;ExplosionGrab
[State -1, ExplosionGrab]
type = ChangeState
value = 1025
triggerall = command = "explosiongrab"
trigger1 = statetype = S
trigger1 = ctrl

;Overhead Stick Spin
[State -1, Overhead Stick Spin]
type = ChangeState
value = 1030
triggerall = command = "overhead_stick"
trigger1 = statetype = S
trigger1 = ctrl

;;;;;;;;;;;;;;;;;;;;;
;;; REGULAR MOVES ;;;
;;;;;;;;;;;;;;;;;;;;;

;---------------------------------------------------------------------------
;Throw
;
[State -1, Throw]
type = ChangeState
value = 235
triggerall = command = "b"
triggerall = statetype = S
triggerall = ctrl
triggerall = stateno != 100
triggerall = P2BodyDist X = [0, 20]
trigger1 = command = "holdfwd"
trigger1 = (p2statetype = S) || (p2statetype = C)
trigger1 = p2movetype != H
trigger2 = command = "holdback"
trigger2 = (p2statetype = S) || (p2statetype = C)
trigger2 = p2movetype != H

;Standing Elbow
[State -1, Standing Elbow]
type = ChangeState
value = 210
triggerall = command = "forward_a"
triggerall = P2BodyDist X = [0, 20]
trigger1 = statetype = S
trigger1 = ctrl

;Knee
[State -1, Knee]
type = ChangeState
value = 225
triggerall = command = "forward_x"
trigger1 = statetype = S
trigger1 = P2BodyDist X = [0, 10]
trigger1 = ctrl

;Sweep
[State -1, Sweep]
type = ChangeState
value = 230
triggerall = command = "sweep"
trigger1 = statetype = S
trigger1 = ctrl

;High Punch
[State -1, High Punch]
type = ChangeState
value = 200
triggerall = command = "a"
trigger1 = statetype = S
trigger1 = ctrl

;Low Punch
[State -1, Low Punch]
type = ChangeState
value = 205
triggerall = command = "b"
trigger1 = statetype = S
trigger1 = ctrl

;High Kick
[State -1, High Kick]
type = ChangeState
value = 215
triggerall = command = "x"
trigger1 = statetype = S
trigger1 = ctrl

;Low Kick
[State -1, Low Kick]
type = ChangeState
value = 220
triggerall = command = "y"
trigger1 = statetype = S
trigger1 = ctrl

;Uppercut
[State -1, Uppercut]
type = ChangeState
value = 400
triggerall = command = "a"
trigger1 = statetype = C
trigger1 = ctrl

;DKickLight
[State -1, DLightKick]
type = ChangeState
value = 405
triggerall = command = "y"
trigger1 = statetype = C
trigger1 = ctrl

;DHardKick
[State -1, DHardKick]
type = ChangeState
value = 410
triggerall = command = "x"
trigger1 = statetype = C
trigger1 = ctrl

;Duck Punch
[State -1, Uppercut]
type = ChangeState
value = 415
triggerall = command = "b"
trigger1 = statetype = C
trigger1 = ctrl

;Jump Kick Light
[State -1, JumpLightKick]
type = ChangeState
value = 600
triggerall = command = "y"
trigger1 = statetype = A
trigger1 = ctrl

;Jump Kick Heavy
[State -1, JumpHardKick]
type = ChangeState
value = 605
triggerall = command = "x"
trigger1 = statetype = A
trigger1 = ctrl

;Jump Punch Light
[State -1, JumpLightKick]
type = ChangeState
value = 610
triggerall = command = "b"
trigger1 = statetype = A
trigger1 = ctrl

;Jump Punch Heavy
[State -1, JumpHardKick]
type = ChangeState
value = 615
triggerall = command = "a"
trigger1 = statetype = A
trigger1 = ctrl